
        .MODEL  SMALL
        .STACK  512

        .DATA?

        .CODE

;---------------------------------------------------------------------------------------

xyz     PROC    FAR

;initialize the data segment register

        mov     ax,@DATA
        mov     ds,ax

;add 2 numbers together

        mov     ax,5
        mov     bx,3
        call    SUM

;convert the result to an ASCII decimal string and display it

        call    U2Dec

;wait for a keypress

        mov     ah,0
        int     16h

;terminate program

        mov     ax,4C00h
        int     21h

xyz     ENDP

;---------------------------------------------------------------------------------------

SUM     PROC    NEAR

;add 2 numbers together
;
;Call With: AX = first number
;           BX = second number
;
;  Returns: AX = total

        add     ax,bx
        ret

SUM     ENDP

;---------------------------------------------------------------------------------------

U2Dec   PROC

;display unsigned word from AX in decimal
;the number is terminated with a carriage return/line feed
;all registers are preserved, including flags

        pushf
        push    ax
        push    bx
        push    cx
        push    dx
        push    si
        push    di
        push    bp
        mov     bx,240Ah             ;line feed and terminator
        push    bx
        mov     bx,0D00h             ;carriage return
        push    bx
        mov     bp,sp
        sub     sp,4
        mov     bx,10

U2Dec0: xor     dx,dx
        div     bx
        or      dl,30h
        mov     [bp],dl
        dec     bp
        or      ax,ax
        jnz     U2Dec0

        inc     bp
        mov     dx,bp
        mov     ah,9
        push    ds
        push    ss
        pop     ds
        int     21h
        pop     ds

        add     sp,8
        pop     bp
        pop     di
        pop     si
        pop     dx
        pop     cx
        pop     bx
        pop     ax
        popf
        ret

U2Dec   ENDP

;---------------------------------------------------------------------------------------

        END     xyz                    ;entry is xyz